/**
 *
 * $Id: main.cpp,v 1.3 2005/03/28 12:53:09 mviara Exp $
 * $Author: mviara $
 * $Name:  $
 *
 * Programma principale.
 * 
 * $Log: main.cpp,v $
 * Revision 1.3  2005/03/28 12:53:09  mviara
 * Added support for xterm, fixed bug in attributr at begin of line.
 *
 * Revision 1.2  2004/11/10 18:40:17  mviara
 * Version 2.01
 *
 * Revision 1.1.1.1  2004/07/10 12:33:22  mviara
 * Migrated from RCS
 *
 *
 * 
 */

#include "ansi.hpp"

static char rcsinfo[]= "$Id: main.cpp,v 1.3 2005/03/28 12:53:09 mviara Exp $";

#define	DEVICETELNET
//#define	DEVICEECHO

static void Help()
{
	printf("%s\n\n",copyright);
	printf("Program usage : ANSI32 [option(s))] [host[:port]]\n\n");
	printf("\thost\tName of the host\n");
	printf("\t-h\tDisplay this message\n");
	printf("\t-kn\tKeyboard code (1 = usa,39 =italian,0 = auto)\n");
	printf("\t-e\tForce numeric pad on (WIN95)\n");
	printf("\t-mx\tConnection mode :\n");
	printf("\t\tT = require host\n");
	printf("\t\tE = echo\n");
	printf("\t-rproxy[:port][\tUse the specified proxy default port 8080\n");
	printf("\t-pname\tDefine the printer device name\n");
	printf("\t-s\tSelect printer before any usage\n");
	printf("\t-d\tPrint using double buffer\n");
	printf("\t-1\tEnable only one session\n");
	printf("\t-a\tEnable SCOANSI emulation\n");
	printf("\t-v\tEnable VT100 emulation\n");
	printf("\t-x\tEnable LINUX emulation\n");
	printf("\t-t\tEnable XTERM emulation (default)\n");
	printf("\n\tDefault options -t -k0 -plpt1 -mT\n");
	exit(1);
}

CAnsi::EMode termMode;
//= CAnsi::Ansix364;
int	doubleBuffer = 0;
int	selectPrinter = 0;
			
int main(int argc,char **argv)
{
	int i;
	char *p;
	char *parameter = 0;
	int	mode = 'T';
	CDeviceTelnet * dt=0;
	CDeviceECHO   * de=0;
	CDevice * device = 0;
	char * printer = 0;
	int	keyboard = 0;
	int flagOne = 0;
	char * proxy = 0;
	int pad = 0;
	
	termMode = CAnsi::Xterm;
		  
	
	for (i = 1 ;  i < argc ; i++)
	{
		p = argv[i];
		
		if (*p == '-')
		{
			p++;
			switch (*p)
			{
				case	'1':
						flagOne = 1;
						break;
						
				case	's':
				case	'S':
					selectPrinter = 1;
					break;

				case	'd':
				case	'D':
					doubleBuffer = 1;
					break;
				case	'a':
				case	'A':
					termMode = CAnsi::Ansix364;
					break;
				case	'T':
				case	't':
					termMode = CAnsi::Xterm;
					break;
				case	'x':
				case	'X':
					termMode = CAnsi::Linux;
					break;
				case	'v':
				case	'V':
					termMode = CAnsi::Vt100;
					break;
					
				case	'k':
				case	'K':
					keyboard = atoi(p+1);
					break;
				case	'p':
				case	'P':
					printer = p+1;
					break;
					
				case	'h':
				case	'?':
				case	'H':
					Help();
					break;
				case	'r':
				case	'R':
						proxy = p + 1;
						break;
						
				case	'e':
				case	'E':
						pad = 1;
						break;
						
				case	'm':
				case	'M':
					p++;
					mode = toupper(*p);
					break;
						
			}
		}
		else
			parameter = p;
			
	}


	CAdapterNT c(keyboard,pad);

	switch (mode)
	{
		default:
			Help();
			break;
			
		case	'T':
			if (parameter == 0)
				Help();
			dt = new CDeviceTelnet(parameter);
			device = dt;
			break;
		case	'E':
			de = new CDeviceECHO;
			device = de;
			break;
	}
	
	CAnsi a(&c,device,termMode,selectPrinter,doubleBuffer);

	//
	// Qu isetta gli eventuali parametri
	//
	if (printer != 0)
		a.SetPrinterName(printer);
	
	if (flagOne)
		a.SetSwitch(0);

	if (proxy != 0)
		device->SetProxy(proxy);
	
	a.AddScreen(0);

	
	a.Main();

	if (de)
	    delete de;

	if (dt)
 	   delete dt;

	return 0;
}
